#define	DWORD s32
#define	WORD s16

#define REQUEST	12
#define	VALUE	0
#define TIMEOUT	500

#define	SMC_MANUFACTURER	0xEC	// SAMSUNG ELECTRONICS ID
#define	SMC_64M				0x76	// 64M ID
#define	SMC_128M			0x79	// 128M ID


#define EP2_PACKET_LENGTH		64

#pragma pack(push, 1)
typedef struct              // SMC REQUEST FORMAT
{
	DWORD	dwPage;
	WORD	wOffset;
	WORD	wLen;
} SMC_REQUEST;
#pragma pack(pop)

#pragma pack(push, 1)
typedef struct			    // IO REQUEST FORMAT
{
	s16	wAddressL;			// ׻ 0
	s8  cAddressH;			// ׻ 0
	s16	wSize;              // Command Length
	s8  cCommand;           // Vendor Command
} IO_REQUEST;
#pragma pack(pop)


typedef struct {
		u8  size;
		u8  manufacturer;
		u16 block_cnt;
		s8  page_per_block;
} SMC_INFO;


#define VENDOR_CMD_SETUP_DMA_REQUEST        0x0471
#define VENDOR_CMD_GET_FIRMWARE_VERSION     0x0472
#define VENDOR_CMD_GET_SET_TWAIN_REQUEST    0x0473
#define VENDOR_CMD_GET_BUFFER_SIZE          0x0474
#define VENDOR_CMD_READ_SMC_PAGE            0x0475
#define VENDOR_CMD_WRITE_SMC_PAGE           0x0476
#define VENDOR_CMD_ERASE_SMC_BLOCK          0x0477
#define VENDOR_CMD_GET_FREE_BLOCK_LIST      0x0478
#define VENDOR_CMD_FORMAT                   0x0479
#define VENDOR_CMD_GET_SMC_INFO             0x047a
#define VENDOR_CMD_GET_ROOT_BLOCK           0x047b
#define VENDOR_CMD_DELETE                   0x047c





#define	STATUS_BAD_BLOCK	0x0000
#define	STATUS_ROOT_BLOCK	0x0001
#define	STATUS_LAST_BLOCK	0xFFF8
#define	STATUS_EMPTY_BLOCK	0xFFFF

#define	ATTR_DATA_BLOCK		0xFF
#define	ATTR_ROOT_BLOCK		0xEE
#define	ATTR_SUB_BLOCK		0xcc


#pragma pack(push, 1)
typedef struct {
	u16	status;
	u8	attribute;
	u16	format_date;
	u16	format_time;
	u8  volume_label[9];
} C_AREA;	//  ǥ
#pragma pack(pop)


#define	ATTR_READONLY		0x00000001B
#define	ATTR_HIDDENFILE		0x00000010B
#define	ATTR_SYSTEMFILE		0x00000100B
#define	ATTR_VOLUMELABEL	0x00001000B
#define	ATTR_SUB_DIR		0x00010000B
#define	ATTR_IS_MODIFY		0x00100000B
#define	ATTR_NOT_USED1		0x01000000B
#define	ATTR_NOT_USED2		0x10000000B


#pragma pack(push, 1)
typedef struct {
	u8 name[18];
	u8 extention[3];
	u8 attribute;
	u16 time;
	u16 date;
	u16 start_block;
	u32 size;
} FILE;
#pragma pack(pop)



