#include "mas35x9_proc.h"
#include "misc.h"

int	proc_init()
{
	proc_de_MAS35x9 = create_proc_entry("MAS35x9", S_IFDIR | S_IRUGO, NULL);	

	if(proc_de_MAS35x9 == NULL)
		return FALSE;

	proc_de_info = create_proc_entry("info", S_IFREG | S_IWUGO, proc_de_MAS35x9);

	if(proc_de_info == NULL){
		remove_proc_entry("MAS35x9", NULL);

		return FALSE;
	}

	proc_de_info->proc_fops = &proc_info_fops;

	/*
	proc_de_tmp = create_proc_entry("tmp", S_IFREG | S_IWUGO, proc_de_MAS35x9);
	if(proc_de_tmp == NULL){
		remove_proc_entry("info", NULL);
		remove_proc_entry("MAS35x9", NULL);

		return FALSE;
	}
	proc_de_tmp->write_proc = proc_tmp_write;
	*/

	return TRUE;
}


void proc_exit()
{
	remove_proc_entry("info",	NULL);
	remove_proc_entry("MAS35x9",	NULL);
}


ssize_t info_read(struct file* info_file, char* buf, size_t count, loff_t * offset)
{
	static int bFirst = 0;
	int length_to_copy = -1;

	length_to_copy = mas35x9_proc_info_init();

	if(-1 == length_to_copy)
	{
		printk("-1\n");
		return -1;
	}
	else
	{
		if(bFirst ==0){	// first read
			copy_to_user(buf, info_str, length_to_copy);
			bFirst = 1;
		}
		else{
			bFirst = 0;
			return -1;
		}
	}

	return length_to_copy;
}

